//+------------------------------------------------------------------+
//|                                                         none.mqh |
//|                                      Copyright 2018, nicholishen |
//|                                                    interwebs.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, nicholishen"
#property link      "interwebs.com"
#ifdef __MQL4__
#property strict
#endif 

class _NoneType
{
 public:
   static double   None(double _)     { return DBL_MAX;   }
   static int      None(int _)        { return INT_MAX;   }
   static uint     None(uint _)       { return UINT_MAX;  }
   static long     None(long _)       { return LONG_MAX;  }
   static ulong    None(ulong _)      { return ULONG_MAX; }
   static char     None(char _)       { return CHAR_MAX;  }
   static uchar    None(uchar _)      { return UCHAR_MAX; }
   static short    None(short _)      { return SHORT_MAX; }
   static ushort   None(ushort _)     { return USHORT_MAX;}
   static string   None(string _)     { return "__NONE-*-*-STRING__";}
   static color    None(color _)      { return clrNONE;   }
   static datetime None(datetime _)   { return -1;        }
   template<typename T>
   static T        None(T _)          { return NULL;      }
};
#define NONE(T)  _NoneType::None((T)NULL)

#define NONE_DOUBLE  DBL_MAX
#define NONE_INT     INT_MAX
#define NONE_UINT    UINT_MAX
#define NONE_LONG    LONG_MAX
#define NONE_ULONG   ULONG_MAX
#define NONE_CHAR    CHAR_MAX
#define NONE_UCHAR   UCHAR_MAX
#define NONE_SHORT   SHORT_MAX
#define NONE_USHORT  USHORT_MAX
#define NONE_COLOR   clrNONE
#define NONE_DATETIME -1
#define NONE_POINTER NULL
#define NONE_STRING  "__NONE-*-*-STRING__"